/*
 * get_assem  kise kenji.
 * last update 1996.10.29
 *
 ************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>

#include "define.h"

char *check_register(int no){

  char *temp;
  char temp_t[256];
  char reg_no[256];
  
  temp = temp_t;

  if(no<8){          /* 0 to7 */
    strcpy(temp, "%g");
  }
  if(no>7 && no<16){ /* 8 to 15 */
    strcpy(temp, "%o");
    no -=8;
  }
  if(no>15 && no<24){ /* 16 to 23 */
    strcpy(temp, "%l");
    no -=16;
  }
  if(no>23 && no<32){ /* 24 to 31 */
    strcpy(temp, "%i");
    no -=24;
  }
  sprintf(reg_no,"%d", no);
  strcat(temp, reg_no);
  
  return temp;
}

char *type3(unsigned int ir)
{
  unsigned int simm, rd, rs1, rs2;
  int simm13,i;
  int fop2;
  char *buff;
  char *temp;

  char buff_t[256];
  char temp_t[256];

  buff = buff_t;
  temp = temp_t;
  
  rd  = (ir >> 25) & 32;
  rs1 = (ir >> 14) & 32;
  if (((ir >> 13) & 1) ==1){
    simm = ir & 0xFFF;
    rs2 = 0;
  }
  else{
    rs2 = ir & 0xFF;
    simm =0;
  }
  
  strcpy(buff, "");
  fop2= (ir >> 19) & 0x3F;
  switch(fop2)
    {
    case 0:     strcpy(buff, "ld");        break;
    case 0x10:  strcpy(buff ,"lda");       break;
    case 0x30:  strcpy(buff ,"ldc");       break;
    case 0x31:  strcpy(buff ,"ldcsr");     break;
    case 0x3:   strcpy(buff ,"ldd");       break;
    case 0x13:  strcpy(buff ,"ldda");      break;
    case 0x33:  strcpy(buff ,"lddc");      break;
    case 0x23:  strcpy(buff ,"lddf");      break;
    case 0x20:  strcpy(buff ,"ldf");       break;
    case 0x21:  strcpy(buff ,"ldfsr");     break;
    case 0x9:   strcpy(buff ,"ldsb");      break;
    case 0x19:  strcpy(buff ,"ldsba");     break;
    case 0xA:   strcpy(buff ,"ldsh");      break;
    case 0x1A:  strcpy(buff ,"ldsha");     break;
    case 0xD:   strcpy(buff ,"ldstub");    break;
    case 0x1D:  strcpy(buff ,"ldstuba");   break;
    case 0x1:   strcpy(buff ,"ldub");      break;
    case 0x11:  strcpy(buff ,"lduba");     break;
    case 0x2:   strcpy(buff ,"lduh");      break;
    case 0x12:  strcpy(buff, "lduha");     break;
    }

  if(strcmp(buff,"")){  
    i   = (ir >> 13) & 0x1;
    rd  = (ir >> 25) & 0x1F;
    rs1 = (ir >> 14) & 0x1F;
    rs2 = (ir      ) & 0x1F;
    
    simm13 = ir & SIMM13;
    if( (simm13 & BIT12)>>12 ) simm13=(ir & SIMM13) | EXTND13;
    /* get sign extended ,negative value */
    
    if(i==0){
      strcat(buff, "  [ ");
      strcat(buff, check_register(rs1));
      strcat(buff, " + ");
      strcat(buff, check_register(rs2));
      strcat(buff, " ],");
      strcat(buff, check_register(rd));
    }
    else{
      if(simm13<0)
	sprintf(temp,"%d", simm13); /* negative */
      else
	sprintf(temp,"0x%x", simm13); /* positive */
      strcat(buff, "  [");
      strcat(buff, (char *)check_register(rs1));
      strcat(buff, " + ");
      strcat(buff, temp);
      strcat(buff, "], ");
      strcat(buff, (char *)check_register(rd));
    }
    return buff;
  }

  switch(fop2)  /* not load above */
    {
    case 0x4:   strcpy(buff ,"st");         break;
    case 0x14:  strcpy(buff ,"sta");        break;
    case 0x5:   strcpy(buff ,"stb");        break;
    case 0x15:  strcpy(buff ,"stba");       break;
    case 0x34:  strcpy(buff ,"stc");        break;
    case 0x35:  strcpy(buff ,"stcsr");      break;
    case 0x7:   strcpy(buff ,"std");        break;
    case 0x17:  strcpy(buff ,"stda");       break;
    case 0x37:  strcpy(buff ,"stdc");       break;
    case 0x36:  strcpy(buff ,"stdcq");      break;
    case 0x27:  strcpy(buff ,"stdf");       break;
    case 0x26:  strcpy(buff ,"stdfq");      break;
    case 0x24:  strcpy(buff ,"stf");        break;
    case 0x25:  strcpy(buff ,"stfsr");      break;
    case 0x6:   strcpy(buff ,"sth");        break;
    case 0x16:  strcpy(buff ,"stha");       break;
    case 0xF:   strcpy(buff ,"swap");       break;
    case 0x1F:  strcpy(buff ,"swapa");      break;
    default:    strcpy(buff ,"case3 default");  break;
    }
  i   = (ir >> 13) & 0x1;
  rd  = (ir >> 25) & 0x1F;
  rs1 = (ir >> 14) & 0x1F;
  rs2 = (ir      ) & 0x1F;
  
  simm13 = ir & SIMM13;
  if( (simm13 & BIT12)>>12 ) simm13=(ir & SIMM13) | EXTND13;
  /* get sign extended ,negative value */
  
  if(i==0){
    strcat(buff, "  ");
    strcat(buff, check_register(rd));
    strcat(buff, ", [ ");
    strcat(buff, check_register(rs1));
    strcat(buff, " + ");
    strcat(buff, check_register(rs2));
    strcat(buff, "]");
  }
  else{
    if(simm13<0)
      sprintf(temp,"%d", simm13); /* negative */
    else
      sprintf(temp,"0x%x", simm13); /* positive */
    strcat(buff, "  ");
    strcat(buff, (char *)check_register(rd));
    strcat(buff, ", [");
    strcat(buff, (char *)check_register(rs1));
    strcat(buff, " + ");
    strcat(buff, temp);
    strcat(buff, "]");
  }
  return buff;
}


char *type2(unsigned int ir) /* arithmetic/logic */
{
  unsigned int fop2;
  unsigned int opc;  
  int i;
  unsigned int rd,rs1,rs2;
  int simm13;
  unsigned int cond,a;
  char *buff;
  char *temp;

  char buff_t[256];
  char temp_t[256];

  buff = buff_t;
  temp = temp_t;

  i = (ir >> 13) & 1;

  strcpy(buff, ""); /* initialize buff[] */
  
  fop2= (ir >> 19) & 0x3F;
  opc = (ir >>  5) & 0x1FF;
  switch(fop2)
    {
    case 0x0:   strcpy(buff ,"add");       break;
    case 0x10:  strcpy(buff ,"addcc");     break;
    case 0x8:   strcpy(buff ,"addx");      break;
    case 0x18:  strcpy(buff ,"addxcc");    break;
    case 0x1:   strcpy(buff ,"and");       break;
    case 0x11:  strcpy(buff ,"andcc");     break;
    case 0x5:   strcpy(buff ,"andn");      break;
    case 0x15:  strcpy(buff ,"andncc");    break;
    case 0x24:  strcpy(buff ,"mulscc");    break;
    case 0x2:   strcpy(buff ,"or");        break;
    case 0x12:  strcpy(buff ,"orcc");      break;
    case 0x6:   strcpy(buff ,"orn");       break;
    case 0x16:  strcpy(buff ,"orncc");     break;
    case 0x25:  strcpy(buff ,"sll");       break;
    case 0x27:  strcpy(buff ,"sra");       break;
    case 0x26:  strcpy(buff ,"srl");       break;
    case 0x4:   strcpy(buff ,"sub");       break;
    case 0x14:  strcpy(buff ,"subcc");     break;
    case 0xC:   strcpy(buff ,"subx");      break;
    case 0x1C:  strcpy(buff ,"subxcc");    break;
    case 0x20:  strcpy(buff ,"TADDcc");    break;
    case 0x21:  strcpy(buff ,"TSUBcc");    break;
    case 0x22:  strcpy(buff ,"TADDccTV");  break;
    case 0x23:  strcpy(buff ,"TAUBccTV");  break;
    case 0x7:   strcpy(buff ,"xnor");      break;
    case 0x17:  strcpy(buff ,"xnorcc");    break;
    case 0x3:   strcpy(buff ,"xor");       break;
    case 0x13:  strcpy(buff ,"xorcc");     break;
    case 0x3D:  strcpy(buff ,"restore");   break;
    case 0x3C:  strcpy(buff ,"save");      break;
    case 0x29:  strcpy(buff ,"rdpsr");     break;
    case 0x2a:  strcpy(buff ,"rdwim");     break;
    case 0x28:  strcpy(buff ,"rdy");       break;
    case 0x2b:  strcpy(buff ,"rdtbr");     break;
    case 0x31:  strcpy(buff ,"wrpsr");     break;
    case 0x33:  strcpy(buff ,"wrtbr");     break;
    case 0x32:  strcpy(buff ,"wrwim");     break;
    case 0x30:  strcpy(buff ,"wry");       break;

    case 0x38:  strcpy(buff ,"jmpl");      break; /*in fact controll*/
      
    }
  if(strcmp(buff,"")){  /* if instruction is part 1 */
    i   = (ir >> 13) & 0x1;
    rd  = (ir >> 25) & 0x1F;
    rs1 = (ir >> 14) & 0x1F;
    rs2 = (ir      ) & 0x1F;
    
    simm13 = ir & SIMM13;
    if( (simm13 & BIT12)>>12 ) simm13=(ir & SIMM13) | EXTND13;
    /* get sign extended ,negative value */
    
    if(i==0){
      strcat(buff, "  ");
      strcat(buff, check_register(rs1));
      strcat(buff, ", ");
      strcat(buff, check_register(rs2));
      strcat(buff, ", ");
      strcat(buff, check_register(rd));
    }
    else{
      if(simm13<0)
	sprintf(temp,"%d", simm13); /* negative */
      else
	sprintf(temp,"0x%x", simm13); /* positive */
      strcat(buff, "  ");
      strcat(buff, (char *)check_register(rs1));
      strcat(buff, ", ");
      strcat(buff, temp);
      strcat(buff, ", ");
      strcat(buff, (char *)check_register(rd));
    }
  }

  
  /* Table 2-25 Control Transfer Buff Opcodes */
  switch(fop2)
    {
/*    case 0x38:
      strcpy(buff ,"jmpl");
      rd  = (ir >> 25) & 0x1F;
      strcat(buff, "  ");
      strcat(buff, (char *)check_register(rd));
      break;
*/      
    case 0x39:
      strcpy(buff ,"RETT");
      break;
      
    case 0x3A: /* ticc */
      cond = (ir >> 25) & 0xF;
      switch(cond)
	{
	case 0:  strcat(buff,"tn");  break;
	case 1:  strcat(buff,"te");  break;
	case 2:  strcat(buff,"tle"); break;
	case 3:  strcat(buff,"tl");  break;
	case 4:  strcat(buff,"tleu");break;
	case 5:  strcat(buff,"tcs"); break;
	case 6:  strcat(buff,"tneg");break;
	case 7:  strcat(buff,"tvs"); break;
	case 8:  strcat(buff,"ta");  break;
	case 9:  strcat(buff,"tne"); break;
	case 10: strcat(buff,"tg");  break;
	case 11: strcat(buff,"tge"); break;
	case 12: strcat(buff,"tgu"); break;
	case 13: strcat(buff,"tcc"); break;
	case 14: strcat(buff,"tpos");break;
	case 15: strcat(buff,"tsvc");break;
	}
      a = (ir >> 29) & 1;
      if (a) strcat(buff, ",a");
      break;
    }
  if(strcmp(buff,""))  return buff;

  /* floating point opcodes */
  if(fop2==0x36)  strcpy(buff ,"cpop1");
  if(fop2==0x37)  strcpy(buff ,"cpop2");     
  if(fop2==0x34 && opc==0x09)  strcpy(buff ,"fabss");    
  if(fop2==0x34 && opc==0x41)  strcpy(buff ,"fadds");     
  if(fop2==0x34 && opc==0x42)  strcpy(buff ,"faddd");     
  if(fop2==0x34 && opc==0x43)  strcpy(buff ,"faddx");       
  if(fop2==0x35 && opc==0x51)  strcpy(buff ,"fcmps");      
  if(fop2==0x35 && opc==0x52)  strcpy(buff ,"fcmpd");    
  if(fop2==0x35 && opc==0x53)  strcpy(buff ,"fcmpx");    
  if(fop2==0x35 && opc==0x55)  strcpy(buff ,"fcmpes");      
  if(fop2==0x35 && opc==0x56)  strcpy(buff ,"fcmped");      
  if(fop2==0x35 && opc==0x57)  strcpy(buff ,"fcmpex");      
  if(fop2==0x34 && opc==0x4d)  strcpy(buff ,"fdivs");        
  if(fop2==0x34 && opc==0x4e)  strcpy(buff ,"fdivd");      
  if(fop2==0x34 && opc==0x4f)  strcpy(buff ,"fdivx");       
  if(fop2==0x34 && opc==0x01)  strcpy(buff ,"fmovs");     
  if(fop2==0x34 && opc==0x49)  strcpy(buff ,"fmuls");       
  if(fop2==0x34 && opc==0x4a)  strcpy(buff ,"fmuld");       
  if(fop2==0x34 && opc==0x4b)  strcpy(buff ,"fmulx");       
  if(fop2==0x34 && opc==0x05)  strcpy(buff ,"fnegs");       
  if(fop2==0x34 && opc==0x29)  strcpy(buff ,"fsqrts");     
  if(fop2==0x34 && opc==0x2a)  strcpy(buff ,"fsqrtd");      
  if(fop2==0x34 && opc==0x2b)  strcpy(buff ,"fsqrtx");    
  if(fop2==0x34 && opc==0x45)  strcpy(buff ,"fsubs");    
  if(fop2==0x34 && opc==0x46)  strcpy(buff ,"fsubd");    
  if(fop2==0x34 && opc==0x47)  strcpy(buff ,"fsubx");  
  if(fop2==0x34 && opc==0xd2)  strcpy(buff ,"fdtoi");  
  if(fop2==0x34 && opc==0xc6)  strcpy(buff ,"fdtos");      
  if(fop2==0x34 && opc==0xce)  strcpy(buff ,"fdtox");    
  if(fop2==0x34 && opc==0xc8)  strcpy(buff ,"fitod");       
  if(fop2==0x34 && opc==0xc4)  strcpy(buff ,"fitos");     
  if(fop2==0x34 && opc==0xcc)  strcpy(buff ,"fitox");   
  if(fop2==0x34 && opc==0xc9)  strcpy(buff ,"fstod");      
  if(fop2==0x34 && opc==0xd1)  strcpy(buff ,"fstoi");     
  if(fop2==0x34 && opc==0xcd)  strcpy(buff ,"fstox");     
  if(fop2==0x34 && opc==0xd3)  strcpy(buff ,"fxtoi");       
  if(fop2==0x34 && opc==0xc7)  strcpy(buff ,"fxtos");     
  if(fop2==0x34 && opc==0xcb)  strcpy(buff ,"fxtod");     

  return buff;
} 

char *type0(unsigned int ir)
{
  unsigned int imm22;
  unsigned int simm, rd, rs1, rs2;
  unsigned int cond,a;
  int fop2;
  char *buff;
  char *temp;

  char buff_t[256];
  char temp_t[256];

  buff = buff_t;
  temp = temp_t;
  
  rd = (ir >> 25) & 32;
  rs1 = (ir >> 14) & 32;
  if (((ir >> 13) & 1) ==1){
    simm = ir & 0xFFF;
    rs2 = 0;
  }
  else{
    rs2 = ir & 0xFF;
    simm =0;
  }
  
  imm22 = (ir & 0x3FFFFF);
  fop2= (ir >> 22) & 0x7;
  
  switch(fop2)
    {
      
    case 0x4: /* sethi */
      rd  = (ir >> 25) & 0x1F;  
      if(rd == 0)
      	strcpy(buff,"nop");
      else{
	strcpy(buff,"sethi");
	strcat(buff,"  ");
	imm22 = (ir << 10 );
	sprintf(temp,"%%hi(0x%x)", imm22); 
	strcat(buff, temp);
	strcat(buff, ", ");
	strcat(buff, (char *)check_register(rd));
      }
      break;
      
    case 0x0:  strcpy(buff, "UNIMP"); break;	  
    case 0x7:  strcpy(buff, "CBccc"); break;
    case 0x6:  strcpy(buff, "FBfcc"); break;
    case 0x2: /* bicc */
      cond = (ir >> 25) & 0xF;
      switch(cond)
	{
	case 0:  strcpy(buff,"bn");  break;
	case 1:  strcpy(buff,"be");  break;
	case 2:  strcpy(buff,"ble"); break;
	case 3:  strcpy(buff,"bl");  break;
	case 4:  strcpy(buff,"bleu");break;
	case 5:  strcpy(buff,"bcs"); break;
	case 6:  strcpy(buff,"bneg");break;
	case 7:  strcpy(buff,"bvs"); break;
	case 8:  strcpy(buff,"ba");  break;
	case 9:  strcpy(buff,"bne"); break;
	case 10: strcpy(buff,"bg");  break;
	case 11: strcpy(buff,"bge"); break;
	case 12: strcpy(buff,"bgu"); break;
	case 13: strcpy(buff,"bcc"); break;
	case 14: strcpy(buff,"bpos");break;
	case 15: strcpy(buff,"bvc"); break;
	}
      a = (ir >> 29) & 1;
      if (a) strcat(buff, ",a");
      break;
      default :  strcpy(buff, "case 0, default");
    }

  return buff;
}

char *get_assem(unsigned int ir)
{
  unsigned int fop;
  char *buff;
  static char temp[256];
  buff = temp;   
  
  fop = (ir >> 30) & 3;

  switch(fop){
  case 0:   buff = (char *)type0(ir);  break;
  case 1:   strcpy(buff,"call %o7");   break;
  case 2:   buff = (char *)type2(ir);  break;
  case 3:   buff = (char *)type3(ir);  break;
  }

  return buff;
}
char *FFget_assem(unsigned int ir)
{
  unsigned int fop;
  char *buff;
  static char temp[256];
  buff = temp;   
  
  fop = (ir >> 30) & 3;

  switch(fop){
  case 0:   buff = (char *)type0(ir);  break;
  case 1:   strcpy(buff,"call %o7");   break;
  case 2:   buff = (char *)type2(ir);  break;
  case 3:   buff = (char *)type3(ir);  break;
  }

  return buff;

}
