#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <sys/types.h>
#include "define.h"

extern unsigned int  ir;         /* current instruction */
extern unsigned int  r[32];      /* integer  register */
extern unsigned int  f[33];      /* floating register */
extern unsigned int  y;          /* y register */
extern unsigned int  n,z,v,c;    /* flags */
extern unsigned int  psr;        /* */
extern unsigned int  pc, npc;    /* program counter, next */
extern unsigned int  fsr;

extern unsigned int  inst_sort;
extern unsigned long long  total_c ;
extern int            toend;

extern char *FFget_assem(unsigned int);
extern unsigned int load_word(unsigned int address);

unsigned int get_hex(char *buf);

void print_status(){
  int i;
  
  printf("tc:%llu ", total_c);
  printf("pc:0x%x ", pc);
  printf("npc:0x%x ", npc);
  printf("%s\n", FFget_assem(ir));
  
  for(i=0; i<8; i++){ /* print registers */
    printf("g%d[%2d]       0x%-8x %-8d \n",i,i, r[i],r[i]);
  }
  for(i=8; i<16; i++){ /* print registers */
    if(i==14)
      printf("sp[%2d]       0x%-8x %-8d \n", i, r[i],r[i]);
    else
      printf("o%d[%2d]       0x%-8x %-8d \n",i%8, i, r[i],r[i]);
  }
  for(i=16; i<24; i++){ /* print registers */
    printf("l%d[%2d]       0x%-8x %-8d \n",i%8, i, r[i],r[i]);
  }
  for(i=24; i<32; i++){ /* print registers */
        if(i==30)
	  printf("fp[%2d]       0x%-8x %-8d \n",i, r[i],r[i]);
	else
	  printf("i%d[%2d]       0x%-8x %-8d \n",i%8, i, r[i],r[i]);
  }
  printf("y            0x%-8x %d\n",y,y);
  printf("psr          0x%-8x %d, c:%d\n",psr,psr, c);
  printf("win\n");
  printf("tbr\n");
  printf("pc           0x%-8x %-8d\n",pc,pc);
  printf("npc          0x%-8x %-8d\n",npc,npc);
  printf("fpsr         0x%-8x %-8d\n",fsr,fsr);
  printf("cpsr\n");
}

void debugmode(){
  int i,j;
  char t_buf[256];
  char t_temp[256];
  static int stop = 1;

  char *buf;
  char *temp;
  
  static long long stop_count = 0;
  static int stop_address = NULL;
  unsigned int address;

  buf = t_buf;
  temp = t_temp;

  if(stop_count==total_c){
    stop = 1;
  }

  if(stop_address==pc){
    stop = 1;
  }
  
  if(stop==1){

    print_status();
    
    printf("(db)");
    gets(buf);

    while(*buf != NULL){
      if(!strncmp(buf,"quit",4)) exit(1);
      
      if(!strcmp(buf,"i r")){ /* information register */
	printf("go 0x0 %x    %d \n",r[0],r[0]);
      }
      
      if(!strcmp(buf,"h")){ /* help */
	printf("  command\n");
	printf("  c followd by number:  stop specified tc.\n");
	printf("  s followd by address: stop specified address.\n");
	printf("  x followd by address: examine specified address.\n");
	printf("  quit: quit simulate.\n");
      }
      
      if(*(buf)=='c'){ /* stop by total count */
	buf++;
	stop_count = atoll(buf); /* for int use atoi */
	printf("stop_tc = %d\n", stop_count);
	stop=0;
	break;
      }

      if(*(buf)=='s'){ /* stop by address */
	buf++;
	stop_address  = get_hex(buf);
	printf("stop_address = 0x%x\n", stop_address);
	stop=0;
	break;
      }

      if(*(buf)=='x'){
	buf++;
	address = get_hex(buf);
	for(j=0; j<20; j++){
	  printf("0x%08x: ", address);
	  for(i=0; i<4; i++){
	    printf("0x%08x ", load_word(address));
	    address +=4;
	  }
	  printf("\n");
	}
      }
      printf("\n");
      
      printf("(db)");
      gets(buf);
    }
  }
}

/*
 * convert hexadecimal value into decimal value
 **************************************************/
unsigned int get_hex(char *buf){
  int i;
  int num;
  int temp=0;
  char t;
  unsigned int sum;
  
  sum=0;
  num = strlen(buf);
  if(num>8){
    printf("hex can treat within 8digit numbers.\n");
    exit(1);
  }
  
  for(i=0; i<num; i++){
    t = *((char *)(buf+(num-i-1)));
    
    switch(t)
      {
      case '0': temp = 0;break;
      case '1': temp = 1;break;
      case '2': temp = 2;break;
      case '3': temp = 3;break;
      case '4': temp = 4;break;
      case '5': temp = 5;break;
      case '6': temp = 6;break;
      case '7': temp = 7;break;
      case '8': temp = 8;break;
      case '9': temp = 9;break;
      case 'a': temp = 10;break;
      case 'b': temp = 11;break;
      case 'c': temp = 12;break;
      case 'd': temp = 13;break;
      case 'e': temp = 14;break;
      case 'f': temp = 15;break;
      }
    sum = sum + temp*( unsigned int)(1 << 4*i);
  }
  return sum;
}


