#include <stdio.h>
#include <memory.h>
#include <stdlib.h>
#include <math.h>
#include "define.h"


extern unsigned int  inst_sort;
extern float f[33];
extern unsigned int fsr;
extern unsigned int total_c;
extern unsigned int pc;

int fprintf();

int fcmps(unsigned int ir)
{
  unsigned int fcc;
  unsigned int opf;
  unsigned int rs1,rs2;
  double ds1,ds2;
  
  rs1 = ( ir & RS1)>>14;
  rs2 = ir & RS2;
  opf = (ir & OPF) >> 5;

  fcc = 0;
  switch(opf)
    {
    case  0x51: inst_sort=_FCMPs_;
      if(f[rs1]==f[rs2]) fcc=0;
      else if(f[rs1]<f[rs2]) fcc=1;
      else if(f[rs1]>f[rs2]) fcc=2;
      else fcc=3;
      break;
      
    case  0x52: inst_sort=_FCMPd_;
      memcpy(&ds1 ,&f[rs1], 8);
      memcpy(&ds2 ,&f[rs2], 8);
      if(ds1==ds2) fcc=0;
      else if(ds1<ds2) fcc=1;
      else if(ds1>ds2) fcc=2;
      else fcc=3;
      break;

    case  0x53: inst_sort=_FCMPx_;
      printf("FCMPx is used, check fpop.c\n");
      exit(1);
      break;
      
    case  0x55:  inst_sort=_FCMPEs_;
      if(f[rs1]==f[rs2]) fcc=0;
      else if(f[rs1]<f[rs2]) fcc=1;
      else if(f[rs1]>f[rs2]) fcc=2;
      else fcc=3;
      break;
      
    case  0x56:  inst_sort=_FCMPEd_;
      memcpy(&ds1 ,&f[rs1], 8);
      memcpy(&ds2 ,&f[rs2], 8);
      if(ds1==ds2) fcc=0;
      else if(ds1<ds2) fcc=1;
      else if(ds1>ds2) fcc=2;
      else fcc=3;
      break;

    case  0x57: inst_sort=_FCMPEx_;
      printf("FCMPEx is used, check fpop.c\n");
      exit(1);
      break;
      
    default:
      fprintf(stderr,"unimplemented fcmp(0x%x).check fpop.c.\n", opf);
      exit(1);
    }
  fsr = (fsr & FCCMASK) | (fcc<<10);
  return 0;
}

int fpops(unsigned int ir)
{

  unsigned int opf;
  unsigned int rd,rs1,rs2;
  unsigned int u_int;
  double dd,ds1,ds2;
  
  rd  = ( ir & RD )>>25;
  rs1 = ( ir & RS1)>>14;
  rs2 = ir & RS2;
  opf = (ir & OPF) >> 5;
  
  switch(opf)
    {

    case   0x9:  inst_sort=_FABSs_;
      if(f[rs2]<0) f[rs2] *=-1;
      f[rd]= f[rs2];
      break;

    case  0x41:  inst_sort=_FADDs_;
/*      printf("FADDs TC:%d, PC:%x\n f[rs1]:%f, f[rs2]:%f ", total_c, pc,
	     f[rs1], f[rs2]); */
      f[rd]=f[rs1]+f[rs2];
/*      printf(" -> f[rd]:%f\n", f[rd]); */
      break;

    case  0x42:  inst_sort=_FADDd_;
      memcpy(&ds1 ,&f[rs1], 8);
      memcpy(&ds2 ,&f[rs2], 8);
/*      printf("FADDd TC:%d, PC:%x, f[rs1] %lf, %lf\n", total_c, pc,
	     ds1, ds2); */
      dd=ds1+ds2;
      memcpy(&f[rd], &dd, 8);
      break;

    case  0x43: inst_sort=_FADDx_;
      printf("FADDx is used, check fpop.c\n");
      exit(1);
      break;

    case  0x4d:  inst_sort=_FDIVs_;
      f[rd]=f[rs1]/f[rs2];
      break;

    case  0x4e:  inst_sort=_FDIVd_;
      memcpy(&ds1 ,&f[rs1], 8);
      memcpy(&ds2 ,&f[rs2], 8);
      dd=ds1/ds2;
      memcpy(&f[rd], &dd, 8);
      break;

    case  0x4f: inst_sort=_FDIVx_;
      printf("FDIVx is used, check fpop.c\n");
      exit(1);
      break;

    case   0x1:  inst_sort=_FMOVs_;
      f[rd]=f[rs2];
      break;

    case  0x49:  inst_sort=_FMULs_;
      f[rd]=f[rs1]*f[rs2];
      break;

    case  0x4a:  inst_sort=_FMULd_;
      memcpy(&ds1 ,&f[rs1], 8);
      memcpy(&ds2 ,&f[rs2], 8);
      dd=ds1*ds2;
      memcpy(&f[rd], &dd, 8);
      break;

    case  0x4b: inst_sort=_FMULx_;
      printf("FMULx is used, check fpop.c\n");
      exit(1);
      break;

    case   0x5:  inst_sort=_FNEGs_;
      f[rs2] *=-1;
      f[rd]=f[rs2];
      break;

    case  0x29:  inst_sort=_FSQRTs_;
      ds2 = (double)f[rs2];
      f[rd] =(float)sqrt(ds2);
      break;

    case  0x2a:  inst_sort=_FSQRTd_;
      memcpy(&ds2 ,&f[rs2], 8);
      dd =sqrt(ds2);
      memcpy(&f[rd], &dd, 8);
      break;

    case  0x2b: inst_sort=_FSQRTx_;
      printf("FSQRTx is used, check fpop.c\n");
      exit(1);
      break;

    case  0x45:  inst_sort=_FSUBs_;
      f[rd]=f[rs1]-f[rs2];
      break;

    case  0x46:  inst_sort=_FSUBd_;
      memcpy(&ds1 ,&f[rs1], 8);
      memcpy(&ds2 ,&f[rs2], 8);
      dd=ds1-ds2;
      memcpy(&f[rd], &dd, 8);
      break;
      
    case  0x47: inst_sort=_FSUBx_;
      printf("FSUBx is used, check fpop.c\n");
      exit(1);
      break;



      
    case 0xd2:  inst_sort=_FdTOi_;
      memcpy(&dd,   &f[rs2],  8);
      u_int = (int)dd;
      memcpy(&f[rd], &u_int, 4);
      break;

    case 0xc6:  inst_sort=_FdTOs_;
      memcpy(&dd, &f[rs2], 8);
      f[rd]=(float)dd;
      break;

    case  0xce: inst_sort=_FdTOx_;
      printf("FdTOx is used, check fpop.c\n");
      exit(1);
      break;

    case 0xc8:  inst_sort=_FiTOd_;
      memcpy(&u_int, &f[rs2], 4);
      dd = (double)u_int;
      memcpy(&f[rd],  &dd,   8);
      break;
      
    case 0xc4:  inst_sort=_FiTOs_;
      memcpy(&u_int, &f[rs2], 4);
      f[rd] = (float)u_int;
      break;

    case  0xcc: inst_sort=_FiTOx_;
      printf("FiTOx is used, check fpop.c\n");
      exit(1);
      break;

    case 0xc9:  inst_sort=_FsTOd_;
      dd = (double)f[rs2];
      memcpy(&f[rd],  &dd,   8);
      break;

    case 0xd1:  inst_sort=_FsTOi_;
      u_int = (int)f[rs2];
      memcpy(&f[rd], &u_int, 4);
      break;

    case 0xcd: inst_sort=_FsTOx_;
      printf("FxTOx is used, check fpop.c\n");
      exit(1);
      break;

    case 0xc3: inst_sort=_FxTOi_;
      printf("FxTOi is used, check fpop.c\n");
      exit(1);
      break;

    case 0xc7: inst_sort=_FxTOs_;
      printf("FxTOs is used, check fpop.c\n");
      exit(1);
      break;

    case 0xcb: inst_sort=_FxTOd_;
      printf("FxTOd is used, check fpop.c\n");
      exit(1);
      break;
      
    default:
      fprintf(stderr,"unimplemented fpop(0x%x).check fpop.c.\n", opf);
      exit(1);
    }
  return 0;
}
