#include <libelf.h>
#include <assert.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <errno.h>
#include <math.h>
#include <signal.h>
#include <fcntl.h>     /* open */
#include <memory.h>
#include <fcntl.h>
#include <time.h>
#include <sys/time.h>
#include <sys/resource.h>
#include <utime.h>
#include <limits.h>
#include <unistd.h>
#include <assert.h>

#include "define.h"


#define LAST_ADDRESS 0xf0000000u 
/* becouse of this setting, compress, sc cant work. */

#define STACK_SIZE  0x400000u
#define STACK_START LAST_ADDRESS - STACK_SIZE /* stack area 10Mbyte */

unsigned char  *mem;        /* memory area   */
unsigned char  *mem_stack;  /* stack area    */
unsigned int th = STACK_START;

extern char *FFget_assem(unsigned int);

extern unsigned int argv_argp_count;
extern unsigned int r[32];
extern unsigned int memory_area;
extern unsigned int pc;
extern unsigned int total_c;
extern unsigned int ir;

/*
 * Translate the address to phisical address.
 **********************************************************/
unsigned int mem_address(unsigned int address){
  
  if(address<memory_area)
    return  (unsigned int)mem +address;
  if(address>=th)
    return  (unsigned int)mem_stack +address-th;

  printf("TC:%d Access address is illegal %u, %x, %s\n",
	 total_c,address, address, FFget_assem(ir));
  printf("mem_area_size %dMbyte\n", memory_area/1000000);
  printf("STACK_START:  0x%x\n", STACK_START);
  printf("STACK_END:    0x%x\n", LAST_ADDRESS);
  exit(1);
}

/************************************************************/
unsigned int load_word(unsigned int address){
  unsigned int tmp;
  memcpy(&tmp, (char *)mem_address(address), 4);
  return tmp;
}

unsigned short load_half(unsigned int address){
  unsigned short tmp;
  memcpy(&tmp, (char *)mem_address(address), 2);
  return tmp;
}

unsigned char load_byte(unsigned int address){
  unsigned char tmp;
  memcpy(&tmp, (char *)mem_address(address), 1);
  return tmp;
}

/************************************************************/
void store_word(unsigned int data, unsigned int address){
  memcpy((char *)mem_address(address), &data, 4);
}

void store_half(unsigned short data, unsigned int address){
  memcpy((char *)mem_address(address), &data, 2);
}

void store_byte(unsigned char data, unsigned int address){
  memcpy((char *)mem_address(address), &data, 1);
}

/************************************************************/
void set_text_area(char *program_name){

  int cnt;
  Elf *          elf;
  Elf32_Shdr *   shdr; /* section header */
  Elf32_Ehdr *   elf_header;
  Elf_Scn *      scn; /* section */
  Elf_Data *     data;
  Elf_Data *     text_data;
  int fd; /* file discripter */
  FILE *program;
  unsigned int sec_addr;
  unsigned int sec_size;

  if(NULL==(program=fopen(program_name,"r"))) assert(0);
  if((fd = open(program_name, O_RDONLY)) == -1) assert(0);
  
  (void) elf_version(EV_CURRENT);
  if ((elf = elf_begin(fd, ELF_C_READ, NULL)) == NULL) exit(1);
    
  if (((elf_header = elf32_getehdr(elf)) == NULL) ||
      ((scn = elf_getscn(elf, elf_header->e_shstrndx)) == NULL) ||
      ((data = elf_getdata(scn, NULL)) == NULL))
    exit(1);

  /* malloc memory area at the beggining of the run */
  for (cnt=1, scn=NULL; scn = elf_nextscn(elf, scn); cnt++) {
    if ((shdr = elf32_getshdr(scn)) == NULL)
      exit(1);
    sec_addr = (unsigned int )shdr->sh_addr;
    sec_size = (unsigned int )shdr->sh_size;
    if(!strcmp((char *)data->d_buf + shdr->sh_name, ".bss")){
      memory_area = sec_addr + sec_size;
      if((mem = (char *)calloc(memory_area, 1))==0){ /* memory area */
	printf("malloc error for mem[] in memory.c\n"); exit(1);}
      break;
    }
  }
  
  for (cnt=1, scn=NULL; scn = elf_nextscn(elf, scn); cnt++) {
    if ((shdr = elf32_getshdr(scn)) == NULL)
      exit(1);

    sec_addr = (unsigned int )shdr->sh_addr;
    sec_size = (unsigned int )shdr->sh_size;

/*
      printf("[%02d]  size:%8d 0x%08x", cnt,
		  sec_size, sec_addr);
      printf(" %d %s\n",
		  shdr->sh_name,
		  (char *)data->d_buf + shdr->sh_name);
*/
    
    if(!strcmp((char *)data->d_buf + shdr->sh_name, ".text")){
      pc = shdr->sh_addr;
    }
    if(!strcmp((char *)data->d_buf + shdr->sh_name, ".bss")){
      break;
    }
    
    if(sec_addr != 0){
      text_data = elf_getdata(scn, NULL);
      memcpy((void *)mem_address(sec_addr),
	     text_data->d_buf, sec_size); 
    }
  }
  fclose(program);
}

/*
 * initialize memory, set environment variables here.
 **********************************************************/
void initialize_memory(int argc, char **argv, char **argp){
  int i,j;
  int k;
  int argpc;
  unsigned int sp;   /* stack point */

  unsigned int string_size;
  unsigned int string_start;
  unsigned int stack_start;
  int ptr_num;
  int fd;
  char char_tmp[10];
  
  if((mem_stack = (char *)malloc(STACK_SIZE+100))==0){ 
    printf("malloc error for mem_stack[] in memory.c\n"); exit(1);}
  memset(mem_stack, 0, STACK_SIZE+100); 

  
  /*  [sp+0x44]=&argv[0], [sp+0x48]=&argv[1] ...  =&argv[n] , 0x00000000,
   argp[0], arg[1],,,,,  0x00000000 */

  string_size=0;
  ptr_num=1;  /* 1 for argc */
  for(i=0; i<(argc-1); i++){
    string_size+=strlen(argv[i+1]);
    string_size++; /* for NULL of each argv */
    ptr_num++;
  }
  ptr_num++;
  for(j=0; 1; j++){  
    if(argp[j]==NULL) break;
    string_size+=strlen(argp[j]);
    string_size++; /* for NULL of each argp */
    ptr_num++;
  }
  ptr_num++;
  string_size+=21; /* for "SUNW,Ultra-1\n" only for xlisp */
  
  if((string_size % 4)!=0) string_size+=(4- (string_size %4));
  string_size+=4;  /* for 0xefffffff NULL */
  
  string_start = LAST_ADDRESS-string_size; /* decide string_starg */
  stack_start = string_start - 4*ptr_num;
  if((stack_start % 8)!=0) stack_start -=4; 

  r[14]= sp = stack_start-0x40;
  
  store_word((argc-1), stack_start);    /* for argc */
  stack_start+=4;

  for(i=0; i<(argc-1); i++){            /* for argv */
    store_word(string_start, stack_start );
    for(k=0; k<strlen(argv[i+1]); k++){
      store_byte( *((argv[i+1])+k), string_start+k); 
    }
    string_start+=strlen(argv[i+1]);
    string_start++;
    stack_start+=4;
  }
  stack_start+=4;
  
  for(j=0; 1; j++){                     /* for argp */
    if(argp[j]==NULL) break;
    store_word(string_start, stack_start);
/*    printf("[%2d] string_start 0x%X %s\n", j, string_start, argp[j]); */
    
    for(k=0; k<strlen(argp[j]); k++)
      store_byte( *((argp[j])+k), string_start+k);
    string_start+=strlen(argp[j]);
    string_start++;
    stack_start+=4;
  }
  
  for(j=0; 1; j++){ 
    if(argp[j]==NULL) break;
  }
  argpc = j;
  argv_argp_count = argpc+argc; /* use only execve */  

/*  printf("memory address 0x%08x - 0x%08x\n", 0, memory_area);
  printf("stack  address 0x%08x - 0x%08x\n", th, LAST_ADDRESS);
  printf("sp[r14] 0x%08x\n\n", sp); */

  if ((fd = open(argv[1], O_RDONLY)) == -1){
    fprintf(stderr, "In memory.c simu can't open program: %s\n",argv[1]);
    exit(1);
  }
  read(fd, char_tmp, 5);
  if(strncmp(&char_tmp[1], "ELF", 3)){
    fprintf(stderr, "In memory.c: %s: This is not elf format.\n",argv[1]);
    exit(0);
  }
  else{
    set_text_area(argv[1]);
  }

  
}
