/* system call for sun_os, kise kenji
 * Should be implemented Syscall 99 and 33. 
 */

#include "define.h"

#include <sys/syscall.h>
#include <sys/types.h> /* stat */
#include <sys/stat.h>  /* stat */
#include <sys/uio.h>   /* writev */
#include <sys/mman.h>
#include <sys/file.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/uio.h>
#include <sys/times.h>
#include <sys/termios.h>
#include <sys/sysconfig.h>

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <errno.h>
#include <math.h>
#include <signal.h>
#include <fcntl.h>     /* open */
#include <memory.h>
#include <fcntl.h>
#include <time.h>
#include <sys/time.h>
#include <sys/resource.h>
#include <utime.h>
#include <limits.h>
#include <unistd.h>
#include <assert.h>


/* global variables */
extern char          *mem;       /* memory area       */
extern char          *mem_temp;  /* temporary mem area*/
extern unsigned int  ir;         /* instruction at pc */
extern unsigned int  r[32], *rr; /* integer  register */
extern float         f[33];      /* floating register */
extern unsigned int  y;          /* y register        */
extern unsigned int  n,z,v,c,fsr;/* flags             */
extern unsigned int  pc, npc;    /* program counter, next */
extern unsigned int  annul;      /* annul bit by *icc inst*/

extern unsigned int memory_area;
extern unsigned int option_flag; /*for option*/
extern FILE *outfile;
extern unsigned int flag;

extern unsigned int mem_address(unsigned int address);
extern int getpagesize(void);

unsigned long long total_c;
int           toend;
int           fd_stdout=0; /* for OUTFILE_PRINT_FLAG */
  
int Ticc(int num)
{
  unsigned int rd=0;
  unsigned int temp;
  unsigned int cond ;
  unsigned int ttrue=0 ;

  if(r[1]>256){
    /* gdb says so, but I'm not sure,
       printf("this ticc is JUST NOP.\n"); */
    return 0;
  }

  
  if(option_flag & SYSTEMCALL_FLAG){ /* r[1] specifies the sort */
    fprintf(OUTFILE1, "[%3d] TC:%07lld pc:%05x  ", r[1], total_c, pc);
    fflush(OUTFILE1);
  }
  
/*  if(num!=0){
    fprintf(stderr, "Ticc exception in syscall.c\n"); exit(1);
  }
*/
  
  if(option_flag & TICC_FLAG)
    fwrite(&total_c, 4, 1, outfile);
  
  cond=(mem[pc] & COND)>>25;

  ttrue = 0;
  switch(cond)
    {
    case  0:                  break;        /* TN   */
    case  1: if(z) ttrue=1;   break;        /* TE   */
    case  2: if(z | (n^v)) ttrue=1; break;  /* TLE  */
    case  3: if(n^v) ttrue=1; break;        /* TL   */
    case  4: if(c|z) ttrue=1; break;        /* TLEU */
    case  5: if(c)   ttrue=1; break;        /* TCS  */
    case  6: if(n)   ttrue=1; break;        /* TNEG */
    case  7: if(v)   ttrue=1; break;        /* TVS  */
    case  8:         ttrue=1; break;        /* TA   */
    case  9: if(!z)  ttrue=1; break;        /* TNE  */      
    case 10: if(!(z|(n^v))) ttrue=1; break; /* TG   */
    case 11: if(!(n^v)) ttrue=1; break;     /* TGE  */
    case 12: if(!(c|z)) ttrue=1; break;     /* TGU  */
    case 13: if(!c)  ttrue=1; break;        /* TCC  */      
    case 14: if(!n)  ttrue=1; break;        /* TPOS */
    case 15: if(!v)  ttrue=1; break;        /* TVC  */
    default:  fprintf(OUTFILE1,"unknown condition ? cond=%x   ",cond);
    }
  
  temp = r[8];

  if(ttrue){ /* as to numbers see /usr/include/syscall.h */
    switch(r[1]) 
      {  /* these cases are not used as system call */
/*      case 13:
      case 21:
      case 22:
      case 23:
      case 25:
      case 27:
      case 28:
      case 29:
      case 30:
      case 31:
      case 32:
      case 34:
      case 35:
      case 39:
      case 43:
      case 45:
      case 46:
      case 48:
      case 49:
      case 50:
      case 52:
      case 56:
      case 63:
      case 66:
      case 67:
      case 68:
      case 77:
      case 84:
      case 103:
      case 107:
      case 119:
      case 132:
      case 143:
      case 147:
      case 148:
      case 149:
      case 154:
      case 164:
      case 184: 
	rd=0;
	if(option_flag & SYSTEMCALL_FLAG)
	  fprintf(OUTFILE1, "syscall[%d] is not implement.", r[1]);
	break;
*/

      case SYS_access: /* this used in SPEC95 tomcatv */
	rd=(int)access((const char *)mem_address(r[8]),r[9]);
	if(option_flag & SYSTEMCALL_FLAG){
	  fprintf(OUTFILE1,"access (\"%s\", %d) = %d",
		  (char *)mem_address(r[8]), r[9], rd);
	  fflush(OUTFILE1);
	}
	
	break;

      case SYS_mmap: /* vortex */
/*	rd=mmap(r[8],r[9],r[10], r[11], r[12],r[13]);
	rd-=0x80000000; */
	
/*	read(r[12], mem_address(rd), r[9]);  */
	if(option_flag & SYSTEMCALL_FLAG){
	  fprintf(OUTFILE1, "mmap(0x%08x,%d, ", r[8],r[9]);
	  if(r[10]==PROT_READ) fprintf(OUTFILE1, "PROT_READ ");
	  if(r[11]==MAP_PRIVATE) fprintf(OUTFILE1, "MAP_PRIVATE ");
	  else fprintf(OUTFILE1, "0x%X ",r[11]);
	  fprintf(OUTFILE1, "%d, %d) = 0x%X\n", r[12],r[13], rd);
	}
	
	printf("mmap is executed. and exit(1)\n");
	exit(1);  
	break;
	
      case SYS_sysconfig:
	if(r[8]==_CONFIG_PAGESIZE){
	  rd=getpagesize();
	}
	if(option_flag & SYSTEMCALL_FLAG) /* compiler says so */
	  fprintf(OUTFILE1, "sysconfig(%d) =  %d ", r[8], rd);
	break;

      case SYS_time: /* vortex */
	rd=time((time_t *)r[8]);
	if(option_flag & SYSTEMCALL_FLAG)
	  fprintf(OUTFILE1, "time() =  %d ", rd);
	break;

      case SYS_times: /* vortex */
	rd=times((struct tms *)mem_address(r[8]));
	if(option_flag & SYSTEMCALL_FLAG)
	  fprintf(OUTFILE1, "times(0x%X) =  %d ", r[8], rd);
	break;
	
      case SYS_getrlimit: /* cc1.v8 use this */
	rd=getrlimit(r[8],(struct rlimit *)mem_address(r[9]));
	if(option_flag & SYSTEMCALL_FLAG)
	  fprintf(OUTFILE1, "getrlimit (%d, 0x%x) =  %d ",
		  r[8], r[9], rd);
	break;
	
      case SYS_setrlimit: /* cc1.v8 use this */
	rd=setrlimit(r[8],(struct rlimit *)mem_address(r[9]));
	if(option_flag & SYSTEMCALL_FLAG)
	  fprintf(OUTFILE1, "setrlimit (%d, 0x%x) =  %d ",
		  r[8], r[9], rd);
	break;
	
	
      case SYS_chmod:
	temp = r[8];
	rd=chmod((const char *)mem_address(r[8]),(mode_t)r[9]);
	if(option_flag & SYSTEMCALL_FLAG)
	  fprintf(OUTFILE1, "chmod (\"%s\", 0%o) = %d ",
		  (char *)mem_address(temp), r[9], rd);
	break;
	
      case SYS_chown:
	rd=chown((const char *)mem_address(r[8]),(uid_t)r[9],(gid_t)r[10]);
	if(option_flag & SYSTEMCALL_FLAG)
	  fprintf(OUTFILE1, "chown (\"%s\", %d, %d) = %d ",
		  (char *)mem_address(temp), r[9], r[10], rd);
	break;
	
      case SYS_unlink:
	rd=unlink((const char *)mem_address(r[8]));
	if(option_flag & SYSTEMCALL_FLAG)
	  fprintf(OUTFILE1, "unlink (\"%s\") = %d ",
		  (char *)mem_address(temp), rd);
	break;
	
      case SYS_stat:
	rd=stat((const char *)mem_address(r[8]),
		(struct stat *)(mem_address(r[9])));
	if(option_flag & SYSTEMCALL_FLAG)
	  fprintf(OUTFILE1, "stat (\"%s\", 0x%x) =  %d ",
		  (char *)(mem_address(r[8])), r[9],rd);
	break;

      case SYS_utime:
	rd=utime((const char *)mem_address(r[8]),
		 (const struct utimbuf *)mem_address(r[9]));
	if(option_flag & SYSTEMCALL_FLAG)
	  fprintf(OUTFILE1, "utime (\"%s\", 0x%X) = %d ",
		  (char *)mem_address(temp), r[9], rd);
	break;
	
      case SYS_fstat:
	rd=fstat(r[8],(struct stat *)(mem_address(r[9])));
	if(option_flag & SYSTEMCALL_FLAG)
	  fprintf(OUTFILE1, "fstat(%d, 0x%08X) = %d ",
		  temp, r[9], rd);
	break;

      case SYS_lstat:
	rd=lstat((const char *)mem_address(r[8]),
		 (struct stat *)(mem_address(r[9])));
	if(option_flag & SYSTEMCALL_FLAG)
	  fprintf(OUTFILE1, "lstat(%s,0x%08x) =  %d ",
		  (char *)mem_address(r[8]), r[9], rd);
	break;
	
      case SYS_exit: /* ok kis */
	toend = 1;
	if(option_flag & SYSTEMCALL_FLAG)
	  fprintf(OUTFILE1, "exit");
	break;

      case SYS_brk:
	rd=0;
	mem = realloc(mem, r[8]);
	memory_area = r[8];
	if(option_flag & SYSTEMCALL_FLAG)
	  fprintf(OUTFILE1, "brk (0x%08X) = %d", r[8],rd);
	break;
	
      case SYS_ioctl:
	rd=ioctl(r[8], r[9], mem_address(r[10]));
	if(option_flag & SYSTEMCALL_FLAG)
	  fprintf(OUTFILE1,"ioctl (%d, 0x%x, 0x%x) = %d",
		  temp, r[9], r[10], rd);
	break;
	
      case SYS_read: /* ok kis */
	if(r[8]>1000){
	  rd=r[8];
	  if(option_flag & SYSTEMCALL_FLAG)
	    fprintf(OUTFILE1,"read () do nothing");
	  break;
	}
	rd=read(r[8], (void *)mem_address(r[9]) ,(size_t)r[10]);
	if(option_flag & SYSTEMCALL_FLAG)
	  fprintf(OUTFILE1, "read (%d,0x%x, %d) = %d",
		  temp, mem_address(r[9]), r[10], rd);
	break;

      case SYS_write: /* ok kis */
	if(r[8]>1000){
	  rd=r[8];
	  if(option_flag & SYSTEMCALL_FLAG)
	    fprintf(OUTFILE1,"write () do nothing");
	  break;
	}
	if(r[8]==1 && (option_flag & STDOUT_TO_FILE)){
	  if(fd_stdout==0){
	    unlink("stdout~"); /* delete file */
	    fd_stdout = open("stdout~", O_CREAT | O_WRONLY, 0644);
	  }
	  r[8]=fd_stdout;
	}
	
	rd=write(r[8], (const void *)mem_address(r[9]),(size_t)r[10]);
	if(option_flag & SYSTEMCALL_FLAG)
	  fprintf(OUTFILE1,"write (%d,0x%x,%d) = %d",
		  temp, mem_address(r[9]),r[10],rd);
	break;

      case SYS_lseek:
	rd=lseek(r[8],r[9],r[10]);
	if(option_flag & SYSTEMCALL_FLAG)
	  fprintf(OUTFILE1, "lseek(%d, %d, %d) >>  %d ",
		  temp, r[9], r[10], rd);
	break;
	
      case SYS_open: /* open chenges c flag  */
	rd=open((char *)mem_address(r[8]),r[9],r[10]);
	if(option_flag & SYSTEMCALL_FLAG){
	  fprintf(OUTFILE1,"open (\"%s\", %d, 0%o) = %d",
		  (char *)mem_address(r[8]), r[9], r[10], rd);
	  fflush(OUTFILE1);
	}
	
	break;

      case SYS_close: /* this couse error ?? */
	if(option_flag & SYSTEMCALL_FLAG)
	  fprintf(OUTFILE1, "close (%d) = %d ",temp, rd);

	if(r[8]==2){
	  rd = 0; /* standard err case */
	  if(option_flag & SYSTEMCALL_FLAG)
	    fprintf(OUTFILE1, "close stderr ignored.");
	}
	else rd=close(r[8]);
	break;

	
      case SYS_sigaction:
	rd=sigaction(r[8], (const struct sigaction *)mem_address(r[9]),
		     (struct sigaction *)mem_address(r[10]));
	if(option_flag & SYSTEMCALL_FLAG){
	  fprintf(OUTFILE1,"sigaction (0x%x, 0x%X, 0x%X) = %d",
		  r[8], r[9], r[10], rd);
	}
	break;
	
      default:
	fprintf(stderr,"System call =%d pc=%x,not implemented.\n",
	       r[1],pc);
	exit(1);
      }
    
  }
  if(rd==FALLMASK)
    {c=1;
     r[8]=errno;
     if(option_flag & SYSTEMCALL_FLAG) fprintf(OUTFILE1, "<%d> ",errno);
   }
  else
    {c=0; r[8] = rd;}

  if(option_flag & SYSTEMCALL_FLAG){
    fprintf(OUTFILE1, "\n");
    fflush(OUTFILE1);
  }
  return 0;
} 
